#include <iosream>
using namespace std;
int najkraciput(int n,int index,int veze[][],int poseceni[],int broj)
{
    poseceni[index]=1;
    int m=0;
    for(i=0;i<n-1;i++)
    {
        if(veze[i][0]==index||veze[i][1]==index)
            m++;
    }
    int nniz[m],j=0;
    for(i=0;i<n-1;i++)
    {
        if(veze[i][0]==index)
            {nniz[j]=veze[i][0];j++;}
        if(veze[i][1]==index)
            {nniz[j]=veze[i][1];j++;}
    }
    int max=broj;
    for(i=0;i<m;i++)
    {
        if(!poseceni&&najkraciput(n,i,veze,poseceni,broj+1)>max)
        {
            max=najkraciput(n,i,veze,poseceni,broj+1);
        }
    }
    return max;
}
int main()
{
    int n;
    cin>>n;
    int niz[n-1][2];
    int ecc[n];
    for(i=0;i<n;i++)
        ecc[i]=0;
    for(int i=0;i<n-1;i++)
        cin>>niz[i][0]>>niz[i][1];
    
    for(i=0;i<n;i++)
    {
        int poseceni[n];
        for(int i=0;i<n;i++)    poseceni[i]=0;
        poseceni[i]=1;
        najkraciput(n,i,veze,poseceni,0);
    }
    return 0;
}